#include "resource.h"
#include "resourcemanager.h"

namespace Msp {
namespace GL {

Resource::Resource():
	manager(0)
{ }

Resource::~Resource()
{
	if(manager)
		manager->remove_resource(*this);
}

void Resource::set_manager(ResourceManager *m)
{
	if(manager)
		manager->remove_resource(*this);
	manager = m;
	if(manager)
	{
		manager->add_resource(*this);
		manager_data = manager->get_data_for_resource(*this);
	}
	else
		manager_data = 0;
}

bool Resource::is_loaded() const
{
	return manager ? manager->is_resource_loaded(*this) : true;
}

} // namespace GL
} // namespace Msp
